/*--------------------------------------------------------------------------
----------------------------------------------------------------------------
--                                                                        --
--     Program Title : BigInt Version 0.4                                 --
--     Author : nex                                                       --
--     Date Last Modified : 1st January 2005                              --
--                                                                        --
--     Description : This program is for the handling of large integers   --
--                   by using a linked list representation. The intended  --
--                   purpose is to provent overflow when wanting to deal  --
--                   with very large integers.                            --
--                                                                        --
--     State of Program: The program is still being tested and has only   --
--                       the functions I have thus far required. It does  --
--                       not contain all the functions one might expect   --
--                       from such a package.                             --
--                                                                        --
----------------------------------------------------------------------------
--------------------------------------------------------------------------*/

#ifndef H_BIGINT
#define H_BIGINT

/**************************************************************************/
/* Representation for big integers (a linked list) */

  struct big_list {
    int Val;
    struct big_list *Next;
    struct big_list *Prev;
  };
  struct big {
    struct big_list *Head;
    struct big_list *Tail;
  };

/**************************************************************************/



/**************************************************************************/
/*---- Function defintions -----------------------------------------------*/

  /* Definitions for the use of the representation of big integers */


    /************************************************************************/
    /* Make a new 'big' integer type with value 'val' (which must be less 
       than 1000 */
    struct big MakeLittleBig(int);


    /************************************************************************/
    /* Outputs the value of the 'big' type 'x' to standard output. */
    void WriteBig(struct big);


    /************************************************************************/
    /* Returns the boolean expression x=y */
    int IsEqual(struct big, struct big);


    /************************************************************************/
    /* Calculates x + y (both of type 'big') and returns as type 'big'. This 
       function is specifically designed for the big type. */
    struct big Add(struct big, struct big);


    /************************************************************************/
    /* This is required to create new 'nodes' in the linked list (i.e. it
       allocates space in memory for next node) */
   struct big_list *lalloc(void);


/**************************************************************************/

#endif
